## coccinelle 1.0.7.deb

=== Makefile ===
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifeq ($(wildcard Makefile.config),)
ifeq ($(wildcard configure),)
$(error To make coccinelle, please run ./autogen and ./configure first)
else
$(error To make coccinelle, please run ./configure first)
endif
else
include Makefile.libs
include Makefile.config
endif
endif
endif
-include Makefile.local

CORE_LIBRARIES := \
	commons globals parsing_cocci parsing_c
LIBRARIES := \
	$(CORE_LIBRARIES) ctl ocaml python engine popl09 extra

TOOLS := spatch spgen

DEPEND_METHOD := multifile

SOURCES_commons := \
	ocamlextra/dumper.ml commands.ml common.ml ograph_simple.ml \
	ograph_extended.ml
SOURCES_globals := \
	config.ml flag.ml iteration.ml $(REGEXP_FILE) regexp.ml
CLEAN_globals := regexp_pcre.ml regexp_str.ml
SOURCES_ctl := \
	flag_ctl.ml ast_ctl.ml pretty_print_ctl.ml ctl_engine.ml wrapper_ctl.ml
SOURCES_parsing_cocci := \
	flag_parsing_cocci.ml ast_cocci.ml ast0_cocci.ml \
	pretty_print_cocci.ml visitor_ast0_types.ml \
	visitor_ast.ml visitor_ast0.ml ast0toast.ml unparse_ast0.ml \
	unify_ast.ml compute_lines.ml iso_pattern.ml comm_assoc.ml \
	iso_compile.ml single_statement.ml simple_assignments.ml \
	get_metas.ml stmtlist.ml check_meta.ml top_level.ml \
	type_infer.ml test_exps.ml unitary_ast0.ml arity.ml index.ml \
	context_neg.ml adjust_pragmas.ml insert_plus.ml function_prototypes.ml \
	semantic_cocci.ml data.ml free_vars.ml safe_for_multi_decls.ml \
	parse_printf.ml parse_aux.ml cleanup_rules.ml disjdistr.ml \
	parser_cocci_menhir.mly lexer_cocci.mll \
	lexer_cli.mll lexer_script.mll \
	cocci_grep.ml dpll.ml get_constants2.ml id_utils.ml git_grep.ml \
	adjacency.ml commas_on_lists.ml re_constraints.ml parse_cocci.ml \
	command_line.ml
SOURCES_parsing_c := \
	token_annot.ml flag_parsing_c.ml parsing_stat.ml \
	token_c.ml ast_c.ml includes.ml control_flow_c.ml \
	visitor_c.ml lib_parsing_c.ml control_flow_c_build.ml \
	pretty_print_c.ml semantic_c.ml lexer_parser.ml parser_c.mly \
	lexer_c.mll parse_string_c.ml token_helpers.ml token_views_c.ml \
	cpp_token_c.ml parsing_hacks.ml cpp_analysis_c.ml \
	unparse_cocci.ml parsing_recovery_c.ml parsing_consistency_c.ml \
	danger.ml parse_c.ml unparse_c.ml unparse_hrule.ml \
	type_c.ml cpp_ast_c.ml \
	type_annoter_c.ml comment_annotater_c.ml \
	compare_c.ml test_parsing_c.ml
SOURCES_ocaml := \
	externalanalysis.ml \
	exposed_modules.ml coccilib.ml ocamlcocci_aux.ml $(OCAMLCOCCI_FILE) \
	prepare_ocamlcocci.ml run_ocamlcocci.ml
CLEAN_ocaml := yes_prepare_ocamlcocci.ml no_prepare_ocamlcocci.ml
SOURCES_python := \
	pycocci_aux.ml $(PYCOCCI_FILE) pycocci.ml
CLEAN_python := yes_pycocci.ml no_pycocci.ml
SOURCES_engine := \
	flag_matcher.ml lib_engine.ml pretty_print_engine.ml \
	check_exhaustive_pattern.ml \
	check_reachability.ml \
	c_vs_c.ml isomorphisms_c_c.ml \
	cocci_vs_c.ml pattern_c.ml transformation_c.ml \
	asttomember.ml asttoctl2.ml ctltotex.ml \
	postprocess_transinfo.ml ctlcocci_integration.ml
SOURCES_popl09 := \
	ast_popl.ml asttopopl.ml insert_quantifiers.ml \
	pretty_print_popl.ml flag_popl.ml popltoctl.ml popl.ml
SOURCES_extra := \
	classic_patch.ml kbuild.ml maintainers.ml

SOURCES_library := \
	flag_cocci.ml cocci.ml testing.ml read_options.ml enter.ml

SOURCES_spatch := \
	$(SOURCES_library) main.ml

SOURCES_spgen := \
	globals.ml ast_tostring.ml detect_patch.ml meta_variable.ml \
	snapshot.ml user_input.ml position_generator.ml disj_generator.ml \
	rule_body.ml rule_header.ml context_rule.ml script_rule.ml \
	file_transform.ml spgen_interactive.ml spgen_lexer.mll spgen_config.ml \
	spgen.ml spgen_test.ml main.ml

PREFIX_spatch :=

PREFIX_spgen := tools/spgen/source/

STDCOMPATDIR := bundles/stdcompat

CORE_LIBS := unix bigarray str \
	$(patsubst %,bytes,$(BYTESDIR)) \
	$(patsubst %,pcre,$(filter %/pcre.cma,$(LNKLIBS))) \
	$(STDCOMPATDIR)/stdcompat

ifeq ($(FEATURE_OCAML),1)
CORE_LIBS += dynlink
endif

LIBS_spatch := $(CORE_LIBS) \
	$(patsubst %,pyml,$(filter %/pyml.cma,$(LNKLIBS)))\
	$(patsubst %,parmap,$(filter %/parmap.cma,$(LNKLIBS)))

LIBS_spgen := $(CORE_LIBS)

LIBRARIES_spatch := $(LIBRARIES)

LIBRARIES_spgen := $(CORE_LIBRARIES)

CORE_BUNDLES=menhirLib pcre stdcompat

ALL_BUNDLES=$(CORE_BUNDLES) parmap pyml

BUNDLES_spatch=$(ALL_BUNDLES)

BUNDLES_spgen=$(CORE_BUNDLES)

SOURCEFILES :=

define foreach_library
SOURCEFILES_$(library) := $(addprefix $(library)/, $(SOURCES_$(library)))
CLEANFILES_$(library) := $(addprefix $(library)/, $(CLEAN_$(library)))
SOURCEFILES+=$$(SOURCEFILES_$(library))
endef
$(foreach library,$(LIBRARIES),$(eval $(foreach_library)))

define foreach_tool
SOURCEFILES_$(tool) := $(addprefix $(PREFIX_$(tool)), $(SOURCES_$(tool)))
SOURCEFILES+=$$(SOURCEFILES_$(tool))
endef
$(foreach tool,$(TOOLS),$(eval $(foreach_tool)))

ifeq ($(MAKECMDGOALS),opt)
NATIVE := yes
else
ifeq ($(MAKECMDGOALS),opt-only)
NATIVE := yes
else
ifeq ($(MAKECMDGOALS),all.opt)
NATIVE := yes
else
ifeq ($(TARGET_SPATCH),byte-only)
NATIVE := no
else
NATIVE := yes
endif
endif
endif
endif

ifeq ($(NATIVE),yes)
LIBSUFFIX := .cmxa
else
LIBSUFFIX := .cma
endif

ifeq ($(NATIVE),yes)
	TOOLS_SUFFIX := .opt
	ALL_OBJECTS := cmo cmx
else
	TOOLS_SUFFIX :=
	ALL_OBJECTS := cmo
endif

EXPOSED_MODULES := \
	$(shell sed -n 's/^.*(\* \(.*\) \*).*$$/\1/p' ocaml/exposed_modules.ml)

COMPILED_EXPOSED_MODULES := \
	$(foreach EXT,cmi $(ALL_OBJECTS),\
		$(patsubst %,ocaml/%.$(EXT), \
			$(notdir $(basename $(EXPOSED_MODULES)))))

SEARCH_PATHS := \
	commons/ocamlextra $(LIBRARIES) $(PREFIX_spgen) $(PCREDIR) $(PYMLDIR) \
	$(PARMAPDIR) $(BYTESDIR) $(STDCOMPATDIR)

SEARCH_PATH_FLAGS := $(addprefix -I ,$(SEARCH_PATHS))

CCLIB := $(patsubst %,-cclib -lparmap_stubs,$(filter %/parmap.cma,$(LNKLIBS))) \
	-cclib -L.

OCAMLC_CMD := $(OCAMLC) $(SEARCH_PATH_FLAGS) $(CCLIB) $(EXTRA_OCAML_FLAGS)

OCAMLOPT_CMD := $(OCAMLOPT) $(SEARCH_PATH_FLAGS) $(CCLIB) $(EXTRA_OCAML_FLAGS)

OCAMLDEP_CMD := $(OCAMLDEP) $(SEARCH_PATH_FLAGS) \
	$(addprefix -ml-synonym ,.mll .mly) \
	$(addprefix -mli-synonym ,.ml .mll .mly)

MENHIR_DEP_CMD := $(MENHIR) --ocamldep "$(OCAMLDEP_CMD)" --depend

MENHIR_CMD := $(MENHIR) --ocamlc "$(OCAMLC_CMD)" --explain --infer

MENHIR_LIB := \
	$(addsuffix /menhirLib$(LIBSUFFIX),$(filter %/menhirLib,$(MAKELIBS)))
PARMAP_LIB := $(addsuffix /parmap$(LIBSUFFIX),$(filter %/parmap,$(MAKELIBS)))
PYML_LIB := $(addsuffix /pyml$(LIBSUFFIX),$(filter %/pyml,$(MAKELIBS)))
PCRE_LIB := $(addsuffix /pcre$(LIBSUFFIX),$(filter %/pcre,$(MAKELIBS)))
STDCOMPAT_LIB := $(STDCOMPATDIR)/stdcompat$(LIBSUFFIX)

STDCOMPAT_USERS := parsing_c/type_annoter_c cocci parsing_cocci/check_meta \
	parsing_cocci/id_utils parsing_cocci/insert_plus \
	parsing_cocci/lexer_cocci ocaml/yes_prepare_ocamlcocci \
	tools/spgen/source/user_input tools/spgen/source/spgen_interactive \
	parsing_c/flag_parsing_c

SHOW_CLEAN := @echo "CLEAN    "
SHOW_OCAMLC := @echo "OCAMLC   "
SHOW_OCAMLOPT := @echo "OCAMLOPT "

ifeq ($(VERBOSE),yes)
RUN_OCAMLDEP = $(OCAMLDEP_CMD)
RUN_OCAMLC = $(OCAMLC_CMD)
RUN_OCAMLC_O = $(OCAMLC_CMD)
RUN_OCAMLOPT = $(OCAMLOPT_CMD)
RUN_OCAMLOPT_O = $(OCAMLOPT_CMD)
RUN_MENHIR = $(MENHIR_CMD)
RUN_OCAMLLEX = $(OCAMLLEX)
RUN_OCAMLYACC = $(OCAMLYACC)
else
RUN_OCAMLDEP = @echo "OCAMLDEP  $<"; $(OCAMLDEP_CMD)
RUN_OCAMLC = $(SHOW_OCAMLC) "$<"; $(OCAMLC_CMD)
RUN_OCAMLC_O = $(SHOW_OCAMLC) "-o $@"; $(OCAMLC_CMD)
RUN_OCAMLOPT = $(SHOW_OCAMLOPT) "$<"; $(OCAMLOPT_CMD)
RUN_OCAMLOPT_O = $(SHOW_OCAMLOPT) "-o $@"; $(OCAMLOPT_CMD)
RUN_MENHIR = @echo "MENHIR    $<"; $(MENHIR_CMD)
RUN_OCAMLLEX = @echo "OCAMLLEX  $<"; $(OCAMLLEX)
RUN_OCAMLYACC = @echo "OCAMLYACC $<"; $(OCAMLYACC)
endif

MKDIR_P := mkdir -p

include Makefile.package

.PHONY : all
all : \
	$(foreach tool,$(TOOLS),$(PREFIX_$(tool))$(tool)$(TOOLS_SUFFIX)) \
	exposed-modules

.PHONY : all-dev
all-dev : byte-only exposed-modules

.PHONY : all.opt
all.opt : opt-only exposed-modules

.PHONY : all-release
all-release : all.opt docs

.PHONY : world
world :  byte-only opt-only exposed-modules docs

.PHONY : exposed-modules
exposed-modules : $(COMPILED_EXPOSED_MODULES) ocaml/parmap.cmi

.PHONY : check
check : spatch$(TOOLS_SUFFIX)
	./spatch$(TOOLS_SUFFIX) --testall

.PHONY : clean
clean :
	$(SHOW_CLEAN) ".depend"
	@rm -f .depend

.PHONY : distclean
distclean : clean
	$(SHOW_CLEAN) "configure"
	@rm -f configure Makefile.config

.PHONY : opt-only opt
opt-only opt : $(foreach tool,$(TOOLS),$(PREFIX_$(tool))$(tool).opt)

.PHONY : byt-only byte-only byte
byt-only byte-only byte : $(foreach tool,$(TOOLS),$(PREFIX_$(tool))$(tool))

.PHONY: install
install: install-spatch install-spgen install-python install-bash install-man

.PHONY: install-bash
install-bash:
	if test "x$(BASH_COMPLETION_DIR)" != "xno"; then \
		$(MKDIR_P) $(DESTDIR)$(BASH_COMPLETION_DIR); \
		$(INSTALL_DATA) scripts/spatch.bash_completion \
			$(DESTDIR)$(BASH_COMPLETION_DIR)/spatch; \
	fi

.PHONY: install-spatch
install-spatch : spatch$(TOOLS_SUFFIX)
	$(MKDIR_P) $(DESTDIR)$(BINDIR) $(DESTDIR)$(LIBDIR)
	$(MKDIR_P) $(DESTDIR)$(LIBDIR)/ocaml
	if test -f bundles/pyml/dllpyml_stubs.so; then \
		$(INSTALL_PROGRAM) bundles/pyml/dllpyml_stubs.so \
			$(DESTDIR)$(LIBDIR); \
	fi
	if test -f bundles/pcre/dllpcre_stubs.so; then \
		$(INSTALL_PROGRAM) bundles/pcre/dllpcre_stubs.so \
			$(DESTDIR)$(LIBDIR); \
	fi
	$(INSTALL_PROGRAM) spatch$(TOOLS_SUFFIX) $(DESTDIR)$(BINDIR)/spatch
	$(INSTALL_DATA) standard.h $(DESTDIR)$(LIBDIR)
	$(INSTALL_DATA) standard.iso $(DESTDIR)$(LIBDIR)
	$(INSTALL_DATA) ocaml/*.cmi $(DESTDIR)$(LIBDIR)/ocaml/
	$(INSTALL_DATA) ocaml/*.cmx $(DESTDIR)$(LIBDIR)/ocaml/

.PHONY : install-man
install-man :
	$(MKDIR_P) $(DESTDIR)$(MANDIR)/man1
	$(MKDIR_P) $(DESTDIR)$(MANDIR)/man3
	$(INSTALL_DATA) docs/spatch.1 $(DESTDIR)$(MANDIR)/man1/
	$(INSTALL_DATA) docs/pycocci.1 $(DESTDIR)$(MANDIR)/man1/
	$(INSTALL_DATA) docs/spgen.1 $(DESTDIR)$(MANDIR)/man1/
	$(INSTALL_DATA) docs/Coccilib.3cocci $(DESTDIR)$(MANDIR)/man3/

.PHONY : install-spgen
install-spgen : tools/spgen/source/spgen$(TOOLS_SUFFIX)
	$(INSTALL_PROGRAM) tools/spgen/source/spgen$(TOOLS_SUFFIX) \
		 $(DESTDIR)$(BINDIR)/spgen

.PHONY : install-python
install-python:
	$(MKDIR_P) $(DESTDIR)$(LIBDIR)/python/coccilib/coccigui
	$(INSTALL_DATA) python/coccilib/*.py \
		$(DESTDIR)$(LIBDIR)/python/coccilib
	$(INSTALL_DATA) python/coccilib/coccigui/*.py \
		$(DESTDIR)$(LIBDIR)/python/coccilib/coccigui
	$(INSTALL_DATA) python/coccilib/coccigui/pygui.glade \
		$(DESTDIR)$(LIBDIR)/python/coccilib/coccigui
	$(INSTALL_DATA) python/coccilib/coccigui/pygui.gladep \
		$(DESTDIR)$(LIBDIR)/python/coccilib/coccigui

.PHONY : uninstall
uninstall : uninstall-bash
	rm -f $(DESTDIR)$(BINDIR)/spatch
	rm -f $(DESTDIR)$(BINDIR)/spatch.opt
	rm -f $(DESTDIR)$(BINDIR)/spatch.byte

.PHONY : uninstall-bash
uninstall-bash :
	rm -f $(DESTDIR)$(BASH_COMPLETION_DIR)/spatch
	rmdir --ignore-fail-on-non-empty -p \
		$(DESTDIR)$(BASH_COMPLETION_DIR)

ml_files_but_parsers := \
	$(filter %.ml,$(SOURCEFILES)) \
	$(patsubst %.mll,%.ml,$(filter %.mll,$(SOURCEFILES)))

.PHONY : docs
docs :
	-$(MAKE) -C docs
	-$(MAKE) docs -C tools/spgen/documentation

.PHONY : mlis
mlis : $(patsubst %.ml,%.mli,$(ml_files_but_parsers))

define foreach_ml_files_but_parsers
ifeq ($(wildcard $(sourcefile:.ml=.mli)),)
$(sourcefile:.ml=.mli) : $(sourcefile)
	$(OCAMLC_CMD) -i $$< >$$@ || (rm $$@; false)
endif
endef
#$(foreach sourcefile,$(ml_files_but_parsers),\
#	$(eval $(foreach_ml_files_but_parsers)))

%.ml.d : %.ml
	$(RUN_OCAMLDEP) $< >$@ || (rm $@; false)

%.mli.d : %.mli
	$(RUN_OCAMLDEP) $< >$@ || (rm $@; false)

%.ml : %.mll
	$(RUN_OCAMLLEX) $<

ml_files := $(ml_files_but_parsers) parsing_c/parser_c.ml
ml_and_mli_files := $(ml_files) $(ml_files:.ml=.mli)

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifeq ($(DEPEND_METHOD),onefile)
.depend : $(ml_and_mli_files) parsing_cocci/parser_cocci_menhir.mly $(MENHIR)
	@echo OCAMLDEP .depend
	@$(OCAMLDEP_CMD) $(ml_and_mli_files) >$@ || (rm $@; false)
	@$(MENHIR_DEP_CMD) parsing_cocci/parser_cocci_menhir.mly >>$@ \
		|| (rm $@; false)

-include .depend

=== popl/Makefile ===
# This file is part of Coccinelle, licensed under the terms of the GPL v2.
# See copyright.txt in the Coccinelle source code for more information.
# The Coccinelle source code can be obtained at http://coccinelle.lip6.fr

#note: if you add a file (a .mli or .ml), dont forget to do a   make depend

ifneq ($(MAKECMDGOALS),distclean)
include ../Makefile.config
-include ../Makefile.local
endif

TARGET = popl

OCAMLCFLAGS ?= -g
OPTFLAGS ?= -g

SRC = ast_popl.ml asttopopl.ml insert_quantifiers.ml insert_befaft.ml \
pretty_print_popl.ml popltoctl.ml popl.ml flag_popl.ml

SYSLIBS=str.cma unix.cma
LIBS=../commons/commons.cma ../globals/globals.cma

INCLUDE_PATH = -I ../commons -I ../globals \
	       -I ../ctl -I ../parsing_c -I ../parsing_cocci -I ../engine

#The Caml compilers.
#for warning:  -w A
#for profiling:  -p -inline 0   with OCAMLOPT
OCAMLC_CMD=$(OCAMLC) $(OCAMLCFLAGS)
OCAMLOPT_CMD=$(OCAMLOPT) $(OPTFLAGS)
OCAMLDEP_CMD=$(OCAMLDEP)
OCAMLMKTOP_CMD=$(OCAMLMKTOP) -g -custom

LIB=$(TARGET).cma
OPTLIB=$(LIB:.cma=.cmxa)

OBJS = $(SRC:.ml=.cmo)
OPTOBJS = $(SRC:.ml=.cmx)

all: $(LIB)
all.opt:
	@$(MAKE) $(OPTLIB) BUILD_OPT=yes

$(TARGET).top: $(LIB)
	$(OCAMLMKTOP_CMD) -o $(TARGET).top $(SYSLIBS) $(LIBS) $(OBJS)

$(LIB):  $(OBJS)
	$(OCAMLC_CMD) -a -o $(LIB) $(OBJS)

clean::
	rm -f $(LIB) $(TARGET).top


$(OPTLIB): $(OPTOBJS)
	$(OCAMLOPT_CMD) -a -o $(OPTLIB) $(OPTOBJS)

# clean rule for LIB.opt
clean::
	rm -f $(OPTLIB) $(LIB:.cma=.a)


.SUFFIXES:
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.cmo:
	$(OCAMLC_CMD) $(INCLUDE_PATH) -c $<

.mli.cmi:
	$(OCAMLC_CMD) $(INCLUDE_PATH) -c $<

.ml.cmx:
	$(OCAMLOPT_CMD) $(INCLUDE_PATH) -c $<


# clean rule for others files
clean::
	rm -f *.cm[iox] *.o *.annot
	rm -f *~ .*~ #*#
	rm -f .depend

distclean: clean

.PHONY: depend
.depend depend:
	$(OCAMLDEP_CMD) $(INCLUDE_PATH) *.mli *.ml > .depend

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
-include .depend
endif
endif

include ../Makefile.common

## coccinelle 1.0.8.deb

=== Makefile ===
--- 
+++ 
@@ -98,12 +98,10 @@
 
 PREFIX_spgen := tools/spgen/source/
 
-STDCOMPATDIR := bundles/stdcompat
-
 CORE_LIBS := unix bigarray str \
+	$(STDCOMPATDIR)/stdcompat \
 	$(patsubst %,bytes,$(BYTESDIR)) \
-	$(patsubst %,pcre,$(filter %/pcre.cma,$(LNKLIBS))) \
-	$(STDCOMPATDIR)/stdcompat
+	$(patsubst %,pcre,$(filter %/pcre.cma,$(LNKLIBS)))
 
 ifeq ($(FEATURE_OCAML),1)
 CORE_LIBS += dynlink
@@ -119,7 +117,7 @@
 
 LIBRARIES_spgen := $(CORE_LIBRARIES)
 
-CORE_BUNDLES=menhirLib pcre stdcompat
+CORE_BUNDLES=stdcompat menhirLib pcre
 
 ALL_BUNDLES=$(CORE_BUNDLES) parmap pyml
 
@@ -381,7 +379,7 @@
 %.ml : %.mll
 	$(RUN_OCAMLLEX) $<
 
-ml_files := $(ml_files_but_parsers) parsing_c/parser_c.ml
+ml_files := $(ml_files_but_parsers) parsing_c/parser_c.ml parsing_cocci/parser_cocci_menhir.ml
 ml_and_mli_files := $(ml_files) $(ml_files:.ml=.mli)
 
 ifneq ($(MAKECMDGOALS),clean)

=== bundles/pyml/Makefile ===
# This Makefile serves as a wrapper to bundle the
# pyml module without modifications.

PYML_VERSION=current

PACKAGE_DIR := pyml-$(PYML_VERSION)
TARBALL=
MODULES=pyml_arch pyutils pytypes pywrappers py pycaml
OBJS=$(MODULES)
INTERFACES=pywrappers py pycaml
C_OBJS=pyml
ARCHIVE=pyml
LIBRARY=pyml
SRC_DIR := $(PACKAGE_DIR)
OTHERS := $(SRC_DIR)/pyml_arch.ml
OCAMLFLAGS+=-I $(STDCOMPATDIR)
CLEANOTHERS=pyml-current/generate pyml-current/generate.cmi \
	pyml-current/generate.cmx pyml-current/generate.cmo \
	pyml-current/generate.cmt pyml-current/generate.cmti \
	pyml-current/generate.o pyml-current/pyml.a \
	pyml-current/pyml.cma pyml-current/pyml.cmxa \
	pyml-current/dllpyml_stubs.so
GENERATED_SOURCE_FILES := $(SRC_DIR)/pywrappers.ml $(SRC_DIR)/pywrappers.mli

ARCH:=$(shell uname)

ifeq ($(ARCH),Linux)
	PYML_ARCH=pyml_arch_linux.ml
else ifeq ($(ARCH),Darwin)
	PYML_ARCH=pyml_arch_darwin.ml
else ifeq ($(findstring CYGWIN,$(ARCH)),CYGWIN)
	PYML_ARCH=pyml_arch_cygwin.ml
else
	$(error Unsupported OS $(ARCH)
endif

include ../Makefile.bundles

ifeq ($(MAKECMDGOALS),all.opt)
	NATIVE := yes
else
	NATIVE := no
endif

include ../../Makefile.package

ifeq ($(NATIVE),yes)
	OCAMLCOPT := $(OCAMLOPT_CMD)
	CMOX := cmx
	CMAX := cmxa
	LINK_BEST := $(LINK_NATIVE)
else
	OCAMLCOPT := $(OCAMLC_CMD)
	CMOX := cmo
	CMAX := cma
	LINK_BEST := $(LINK_BYTECODE)
endif


distclean: clean
	rm -f .prepare

$(SRC_DIR)/pywrappers.ml \
$(SRC_DIR)/pyml_wrappers.inc: \
		$(MARKER) $(SRC_DIR)/generate
	cd $(SRC_DIR) && ./generate

$(SRC_DIR)/pyml_wrappers.inc: $(SRC_DIR)/pywrappers.ml

$(SRC_DIR)/pyml_stubs.o: $(SRC_DIR)/pyml_stubs.c $(SRC_DIR)/pyml_wrappers.inc

$(SRC_DIR)/pyml_arch.mli \
$(SRC_DIR)/$(PYML_ARCH) \
$(SRC_DIR)/generate.ml \
$(SRC_DIR)/pytypes.mli: $(MARKER)

$(SRC_DIR)/pywrappers.mli: \
	$(SRC_DIR)/pywrappers.ml $(SRC_DIR)/pytypes.cmi $(SRC_DIR)/pyml_arch.cmi
	$(OCAMLC_CMD) -i $< >$@

$(SRC_DIR)/pyml_arch.cmx: $(SRC_DIR)/pyml_arch.ml $(SRC_DIR)/pyml_arch.cmi
	$(OCAMLOPT_CMD) -c $< -o $@

$(SRC_DIR)/pyml_arch.cmo: $(SRC_DIR)/pyml_arch.ml $(SRC_DIR)/pyml_arch.cmi
	$(OCAMLC_CMD) -c $< -o $@

$(SRC_DIR)/pyutils.cmo $(SRC_DIR)/pyutils.cmx : $(SRC_DIR)/pyutils.cmi

$(SRC_DIR)/generate : $(SRC_DIR)/pyutils.$(CMOX) $(SRC_DIR)/generate.$(CMOX)
	$(OCAMLCOPT) $(OCAMLLDFLAGS) $(LINK_BEST) stdcompat.$(CMAX) unix.$(CMAX) $^ -o $@

$(SRC_DIR)/generate.cmx: $(SRC_DIR)/generate.ml
	$(OCAMLOPT_CMD) -c $< -o $@

$(SRC_DIR)/generate.cmo: $(SRC_DIR)/generate.ml
	$(OCAMLC_CMD) -c $< -o $@

$(SRC_DIR)/pyml_arch.ml: $(SRC_DIR)/$(PYML_ARCH)
	cp $< $@

=== bundles/stdcompat/Makefile ===
.PHONY : all
all :
	cd stdcompat-current; make && cp *.mli *.cmi *.cmx *.cma *.cmxa *.a ..

.PHONY : clean
clean :
	rm -f *.mli *.cmi *.cmo *.cmt *.cmti *.cmx *.cma *.cmxa *.a
	cd stdcompat-current && \
		rm -f *.cmi *.cmo *.cmx *.cmt *.cmti *.cma *.cmxa *.a *.cmxs

.PHONY : distclean
distclean : clean

=== python/coccilib/Makefile ===
MAKESUBDIRS=coccigui

ifneq ($(MAKECMDGOALS),distclean)
include ../../Makefile.config
-include ../../Makefile.local
endif

all:
all.opt:

depend:

clean:
	set -e; for i in $(MAKESUBDIRS); do $(MAKE) -C $$i clean; done
	rm -rf __pycache__
	rm -f *.pyc

distclean: clean

include ../../Makefile.common

=== bundles/pyml/pyml-current/Makefile ===
PREFIX := /usr/local
OCAMLFIND := ocamlfind
INSTALL := install
INSTALL_PROGRAM := $(INSTALL)
bindir := $(PREFIX)/bin

HAVE_OCAMLFIND := $(shell \
	if $(OCAMLFIND) query -help >/dev/null 2>&1; then \
		echo yes; \
	else \
		echo no; \
	fi \
)

HAVE_UTOP := $(shell \
	if [ "$(HAVE_OCAMLFIND)" = no ]; then \
		echo no; \
	elif $(OCAMLFIND) query utop >/dev/null 2>&1; then \
		echo yes; \
	else \
		echo no; \
	fi \
)

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(HAVE_OCAMLFIND),no)
	OCAMLC := $(OCAMLFIND) ocamlc
	ifneq ($(HAVE_OCAMLOPT),no)
		OCAMLOPTEXE := $(OCAMLFIND) ocamlopt
	endif
	OCAMLMKLIB := $(OCAMLFIND) ocamlmklib
	OCAMLMKTOP := $(OCAMLFIND) ocamlmktop
	OCAMLDEP := $(OCAMLFIND) ocamldep
	OCAMLDOC := $(OCAMLFIND) ocamldoc
	STDCOMPAT := $(shell $(OCAMLFIND) query stdcompat)
else
	OCAMLC := $(shell \
		if ocamlc.opt -version >/dev/null 2>&1; then \
			echo ocamlc.opt; \
		elif ocamlc -version >/dev/null 2>&1; then \
			echo ocamlc; \
		fi \
	)
	ifeq ($(OCAMLC),)
$(error There is no OCaml compiler available in path)
	endif
	ifneq ($(HAVE_OCAMLOPT),no)
		OCAMLOPTEXE := $(shell \
			if ocamlopt.opt -version >/dev/null 2>&1; then \
				echo ocamlopt.opt; \
			elif ocamlopt -version >/dev/null 2>&1; then \
				echo ocamlopt; \
			fi \
		)
	endif
	OCAMLMKLIB := ocamlmklib
	OCAMLMKTOP := ocamlmktop
	OCAMLDEP := ocamldep
	OCAMLDOC := ocamldoc
	STDCOMPAT := .
endif

ifeq ($(wildcard $(STDCOMPAT)/stdcompat.cma),)
$(error stdcompat module not found: please specify the path with STDCOMPAT=...)
endif

OCAMLVERSION := $(shell $(OCAMLC) -version)
endif

ifeq ($(HAVE_UTOP),yes)
	PYMLUTOP := pymlutop
else
	PYMLUTOP :=
endif

ifeq ($(OCAMLOPTEXE),)
	OCAMLOPT = $(error There is no optimizing OCaml compiler available)
	OCAMLCOPT := $(OCAMLC)
	CMOX := cmo
	CMAX := cma
	ALLOPT :=
	TESTSOPT :=
else
	OCAMLOPT := $(OCAMLOPTEXE)
	OCAMLCOPT := $(OCAMLOPT)
	CMOX := cmx
	CMAX := cmxa
	ALLOPT := all.native
	TESTSOPT := tests.native
endif

ifeq (4.06.0,$(word 1,$(sort 4.06.0 $(OCAMLVERSION))))
	PYOPS=pyops
else
	PYOPS=
endif

MODULES := pyml_arch pyutils pytypes pywrappers py pycaml $(PYOPS)

VERSION := $(shell date "+%Y%m%d")

OCAMLCFLAGS := -I $(STDCOMPAT)
OCAMLLDFLAGS := -I $(STDCOMPAT)

OCAMLLIBFLAGS := -cclib "-L. -lpyml_stubs"
OCAMLLIBNUMPYFLAGS := -cclib "-L. -lnumpy_stubs"

OCAMLLIBFLAGSNATIVE := $(OCAMLLIBFLAGS)
OCAMLLIBFLAGSBYTECODE := -custom $(OCAMLLIBFLAGS)

ARCH := $(shell uname)

ifeq ($(ARCH),Linux)
	PYML_ARCH := pyml_arch_linux.ml
else ifeq ($(ARCH),Darwin)
	PYML_ARCH := pyml_arch_darwin.ml
else ifeq ($(findstring CYGWIN,$(ARCH)),CYGWIN)
	PYML_ARCH := pyml_arch_cygwin.ml
else
	$(error Unsupported OS $(ARCH)
endif

INSTALL_FILES := \
	py.mli numpy.mli $(MODULES:=.cmi) $(MODULES:=.cmx) \
	numpy.cmi \
	pyml.cma pyml.cmxa pyml.cmxs pyml.a \
	numpy.cma numpy.cmxa numpy.cmxs numpy.a \
	libpyml_stubs.a dllpyml_stubs.so \
	libnumpy_stubs.a dllnumpy_stubs.so \
	META

.PHONY : all
all : all.bytecode $(ALLOPT)
	@echo The py.ml library is compiled.
	@echo Run \`make doc\' to build the documentation.
	@echo Run \`make tests\' to check the test suite.
ifneq ($(HAVE_OCAMLFIND),no)
	@echo Run \`make install\' to install the library via ocamlfind.
endif
	@echo Run \`make pymltop\' to build the toplevel.
ifneq ($(HAVE_UTOP),no)
	@echo Run \`make pymlutop\' to build the utop toplevel.
endif

.PHONY : help
help :
	@echo make [all] : build the library
	@echo make all.bytecode : build only the bytecode library
	@echo make all.native : build only the native library
	@echo make doc : build the documentation
ifneq ($(HAVE_OCAMLFIND),no)
	@echo make install : install the library via ocamlfind
endif
	@echo make clean : remove all the generated files
	@echo make tests : compile and run the test suite
	@echo make tests.bytecode : run only the bytecode version of the tests
	@echo make tests.native : run only the native version of the tests
	@echo make pymltop: build the toplevel
ifneq ($(HAVE_UTOP),no)
	@echo make pymlutop: build the utop toplevel.
endif
	@echo make HAVE_OCAMLFIND=no : disable ocamlfind
	@echo make HAVE_OCAMLOPT=no : disable ocamlopt
	@echo \
"make OCAMLC|OCAMLOPT|OCAMLMKLIB|OCAMLMKTOP|OCAMLDEP|OCAMLDOC=... :"
	@echo "  set paths to OCaml tools"
	@echo make OCAMLCFLAGS=... : set flags to OCaml compiler for compiling
	@echo make OCAMLLDFLAGS=... : set flags to OCaml compiler for linking
	@echo make OCAMLLIBFLAGS=... :
	@echo "  set flags to OCaml compiler for building the library"
	@echo make STDCOMPAT=... : set path to the stdcompat library

.PHONY : all.bytecode
all.bytecode : pyml.cma numpy.cma

.PHONY : all.native
all.native : pyml.cmxa pyml.cmxs numpy.cmxa numpy.cmxs

.PHONY : tests
tests : tests.bytecode $(TESTSOPT)

.PHONY : tests.bytecode
tests.bytecode : pyml_tests.bytecode numpy_tests.bytecode
	./pyml_tests.bytecode
	./numpy_tests.bytecode

.PHONY : tests.native
tests.native : pyml_tests.native numpy_tests.native
	./pyml_tests.native
	./numpy_tests.native

.PHONY : install
install : $(INSTALL_FILES)
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for 'make install')
endif
	$(OCAMLFIND) install pyml $(INSTALL_FILES)
	[ ! -f pymltop ] || $(INSTALL_PROGRAM) pymltop $(bindir)/pymltop
	[ ! -f pymlutop ] || $(INSTALL_PROGRAM) pymlutop $(bindir)/pymlutop

.PHONY : uninstall
uninstall :
	$(OCAMLFIND) remove pyml
	- rm $(bindir)/pymltop
	- rm $(bindir)/pymlutop

.PHONY : clean
clean :
	for module in $(MODULES) numpy generate pyml_tests_common pyml_tests \
		numpy_tests; do \
		rm -f $$module.cmi $$module.cmo $$module.cmx $$module.a \
			$$module.o; \
	done
	rm -f pyml.cma pyml.cmxa pyml.cmxs pyml.a
	rm -f numpy.cma numpy.cmxa numpy.cmxs numpy.a
	rm -f pywrappers.mli pywrappers.ml pyml_dlsyms.inc pyml_wrappers.inc
	rm -f pyml.h
	rm -f pyml_stubs.o dllpyml_stubs.so libpyml_stubs.a
	rm -f numpy_stubs.o dllnumpy_stubs.so libnumpy_stubs.a
	rm -f pyml_arch.ml
	rm -f generate pyml_tests.native pyml_tests.bytecode
	rm -f numpy_tests.native numpy_tests.bytecode
	rm -f .depend
	rm -rf doc
	rm -f pymltop pytop.cmo pymlutop pyutop.cmo
	rm -f pymltop_libdir.ml pymltop_libdir.cmo

.PHONY : tarball
tarball :
	git archive --format=tar.gz --prefix=pyml-$(VERSION)/ HEAD \
		>pyml-$(VERSION).tar.gz

doc : py.mli pycaml.mli numpy.mli pywrappers.ml
	mkdir -p $@
	$(OCAMLDOC) $(OCAMLCFLAGS) -html -d $@ $^
	touch $@

.depend : $(MODULES:=.ml) $(MODULES:=.mli) numpy.ml numpy.mli \
	pyml_tests_common.mli pyml_tests_common.ml pyml_tests.ml numpy_tests.ml
	$(OCAMLDEP) $^ >$@

ifneq ($(MAKECMDGOALS),clean)
-include .depend
endif

pyutils.cmo pyutils.cmx : pyutils.cmi

generate : pyutils.$(CMOX) generate.$(CMOX)
	$(OCAMLCOPT) $(OCAMLLDFLAGS) stdcompat.$(CMAX) unix.$(CMAX) $^ -o $@

generate.cmo : generate.ml

generate.cmx : generate.ml

pywrappers.ml pyml_wrappers.inc : generate
	./generate

pyml_wrappers.inc : pywrappers.ml

pywrappers.mli : pywrappers.ml pytypes.cmi pyml_arch.cmi
	$(OCAMLC) -i $< >$@

pyml_tests.native : py.cmi pyml.cmxa pyml_tests_common.cmx pyml_tests.cmx
	$(OCAMLOPT) $(OCAMLLDFLAGS) unix.cmxa stdcompat.cmxa pyml.cmxa \
		pyml_tests_common.cmx pyml_tests.cmx -o $@

pyml_tests.bytecode : py.cmi pyml.cma pyml_tests_common.cmo pyml_tests.cmo
	$(OCAMLC) $(OCAMLLDFLAGS) unix.cma stdcompat.cma pyml.cma \
		pyml_tests_common.cmo pyml_tests.cmo -o $@

numpy_tests.native : py.cmi pyml.cmxa numpy.cmxa \
		pyml_tests_common.cmx numpy_tests.cmx
	$(OCAMLOPT) $(OCAMLLDFLAGS) \
		unix.cmxa stdcompat.cmxa pyml.cmxa bigarray.cmxa numpy.cmxa \
		pyml_tests_common.cmx numpy_tests.cmx -o $@

numpy_tests.bytecode : py.cmi pyml.cma numpy.cma \
		pyml_tests_common.cmo numpy_tests.cmo
	$(OCAMLC) $(OCAMLLDFLAGS) unix.cma stdcompat.cma pyml.cma bigarray.cma \
		numpy.cma pyml_tests_common.cmo numpy_tests.cmo -o $@

pyml_arch.ml : $(PYML_ARCH)
	cp $< $@

pyml_arch.cmo pyml_arch.cmx : pyml_arch.cmi

%.cmi : %.mli
	$(OCAMLC) $(OCAMLCFLAGS) -c $< -o $@

%.cmo : %.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c $< -o $@

%.cmx : %.ml
	$(OCAMLOPT) $(OCAMLCFLAGS) -c $< -o $@

%.o : %.c
	$(OCAMLC) -c $< -o $@

pyml_stubs.o : pyml_wrappers.inc

pyml.cma : $(MODULES:=.cmo) libpyml_stubs.a
	$(OCAMLC) $(OCAMLLIBFLAGSBYTECODE) -a $(MODULES:=.cmo) -o $@

pyml.cmxa : $(MODULES:=.cmx) libpyml_stubs.a
	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -a $(MODULES:=.cmx) -o $@

pyml.cmxs : $(MODULES:=.cmx) libpyml_stubs.a
	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -shared $(MODULES:=.cmx) -o $@

lib%.a : %.o
	$(OCAMLMKLIB) -o $(basename $<) $<

numpy.cma : numpy.cmo libnumpy_stubs.a
	$(OCAMLC) -custom $(OCAMLLIBNUMPYFLAGS) -a numpy.cmo -o $@

numpy.cmxa : numpy.cmx libnumpy_stubs.a
	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -a numpy.cmx -o $@

numpy.cmxs : numpy.cmx libnumpy_stubs.a
	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -shared numpy.cmx -o $@

pytop.cmo : pytop.ml pymltop_libdir.cmi
	$(OCAMLC) -I +compiler-libs -c $<

pymltop_libdir.ml :
	if [ -z "$(PREFIX)" ]; then \
	  echo "let libdir=\"$(PWD)\""; \
	else \
	  echo "let libdir=\"$(PREFIX)/lib/pyml/\""; \
	fi >$@

pymltop : pyml.cma numpy.cma pymltop_libdir.cmo pytop.cmo
	$(OCAMLMKTOP) $(OCAMLLDFLAGS) unix.cma stdcompat.cma bigarray.cma $^ \
		-o $@

pyutop.cmo : pyutop.ml
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for utop)
endif
	$(OCAMLC) $(OCAMLCFLAGS) -thread -package utop -c $< -o $@

pymlutop : pyml.cma numpy.cma pymltop_libdir.cmo pytop.cmo pyutop.cmo
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for utop)
endif
#	ocamlmktop raises "Warning 31". See https://github.com/diml/utop/issues/212
#	$(OCAMLMKTOP) -o $@ -thread -linkpkg -package utop -dontlink compiler-libs $^
	ocamlfind ocamlc -thread -linkpkg -linkall -predicates create_toploop \
		-package compiler-libs.toplevel,utop,stdcompat $^ -o $@

=== debian/changelog ===
coccinelle (1.0.8.deb-2) unstable; urgency=medium

  * Team upload.
  * Patch installation-bytecode-only: fix installation on bytecode-only
    architectures.

 -- Ralf Treinen <treinen@debian.org>  Sat, 04 Apr 2020 16:24:07 +0200

coccinelle (1.0.8.deb-1) unstable; urgency=medium

  * Team upload

  [ Emmanuel Arias ]
  * New upstream version 1.0.8.deb
  * New Maintainer (Closes: #886679)
    - Add myself to Uploaders field on d/control
  * Update d/control file
    - Bump debhelper to debhelper-compat (=12)
  * Remove d/compat
  * Run wrap-and-sort
  * Bump Standards-Versions to 4.4.1
  * Update no-bundles.patch
  * Remove unnecessary line on d/gbp.conf
  * Apply patch to remove pygtk dependencies (Closes: #885267).
  * d/patches: Fix no-bundles.diff patch.
  * d/salsa-ci.yml: enable salsa-ci

  [ Ralf Treinen ]
  * Drop patch no-stdcompat.diff, build-depend on libstdcompat-ocaml-dev
  * Create directory usr/lib/coccinelle/python/coccilib
  * debian/rules: drop --parallel argument to dh which is now the default
  * Drop override of dh_dwz which is no longer needed
  * Drop override of dh_clean, put extra files to remove into debian/clean
  * Dropped some build-dependencies:
    - dh-autoreconf (not needed with debhelper compat level 12)
    - libpycaml-ocaml-dev (as indicated by upstream's install.txt)
    - camlp4 (no longer needed, according to the upstream team)
    - hevea (we are not building documentation in html format)
    - latexmk (not needed to build the documentation)
    - ocaml-best-compilers (which is now purely virtual)
  * Move texlive-* build-dependencies to Build-Depends-Indep
  * Dropped some dependencies of the coccinelle binary package as they
    are no run-time dependencies according to upstream:
    - libpycaml-ocaml (python2 removal)
    - python-glade2 (python2 removal)
    - python-gobject-2 (deprecated)
  * Bump build-dependency on python to python3, switch dh plugin from
    python2 to python3 (closes: #936314, #952461)
  * Simplify build:
    - in the build-indep override, just invoke "$(MAKE) docs/manual pdf"
    - drop the build-arch override
    - consequently, drop the patch pdf-docs-build which is no longer useful
  * Add as-installed test
  * Adjust doc-base files as documentation is now installed into
    /usr/share/doc/coccinelle
  * Standards-Version 4.5.0 (no change)
  * Set "Multi-Arch: foreign" for coccinelle-doc 

 -- Ralf Treinen <treinen@debian.org>  Sat, 04 Apr 2020 10:37:51 +0200

coccinelle (1.0.7.deb-1) experimental; urgency=medium

  * New upstream release 
  * Update debian/watch to download releases from Github
  * Point Vcs fields to salsa.debian.org
  * Update debian/repack.sh 
  * Removed patches:
    - notparallel-main-makefile.diff
    - bash-completion-dir.diff
    - fix-noopt-FTBFS.diff 
  * New patches:
    - no-bundles.diff - don't attempt to clean bundles, they were removed by
      debian/repack.sh
    - manual-build-fix.diff - fix building of the manual (closes: #917490)
    - no-stdcompat.diff - don't use stdcompat library, it is not present in
      Debian
    - add-no_pycocci.mli.diff - add no_pycocci.mli so coccinelle can be built
      without Python support 
    - dont-update-test-score.diff - don't update test score so spatch doesn't
      ask questions during build
    - dont-expose-parmap.diff - don't include parmap inside the package
  * Don't install spatch wrapper script, it is not used anymore
  * Don't call "make depend" in debian/rules - the target does not exist
    anymore
  * Don't call "make all" in ocaml subdirectory, this is not needed anymore 
  * Ignore failed tests for now

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 06 Jan 2019 20:36:50 +0100

coccinelle (1.0.6.deb-3) experimental; urgency=medium

  * Pass --disable-opt to configure instead of just not passing --enable-opt
    on architectures without native compilers (again, closes: #886714)
  * New patch:
    - fix-noopt-FTBFS.diff - do not force using optimized compiler so
      --disable-opt actually works
  * Use dh-autoreconf during build

 -- Євгеній Мещеряков <eugen@debian.org>  Wed, 10 Jan 2018 00:51:13 +0100

coccinelle (1.0.6.deb-2) experimental; urgency=medium

  * Use --enable-opt configure option instead of --enable-release, this should
    fix FTBFS on some architectures (closes: #886714)

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 09 Jan 2018 22:03:55 +0100

coccinelle (1.0.6.deb-1) experimental; urgency=medium

  * New upstream release (closes: #852412)
  * Upload to experimental: no Python support
  * Refresh bash-completion-dir.diff
  * Debhelper compatibility level 9
  * Use secure VCS URLs in debian/copyright
  * Standards-Version 4.1.1 - no changes required

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 30 Oct 2017 21:06:45 +0100

coccinelle (1.0.4.deb-3) unstable; urgency=medium

  * Fix package name spelling in the package description, thanks to Thomas
    Vincent for reporting (closes: #824224)

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 16 May 2016 22:37:11 +0200

=== debian/control ===
Source: coccinelle
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Emmanuel Arias <emmanuelarias30@gmail.com>
Build-Depends: debhelper-compat (=12),
               dh-ocaml (>= 1.0.3~),
               dh-python,
               libmenhir-ocaml-dev (>= 20090204.dfsg),
               libparmap-ocaml-dev (>= 1.0~rc4-5~),
               libpcre-ocaml-dev,
	       libstdcompat-ocaml-dev,
               menhir (>= 20090204.dfsg),
               ocaml-findlib,
               ocaml-nox (>= 3.11.1-3~),
               pkg-config (>= 0.9.0),
               python3
Build-Depends-Indep:
               texlive-fonts-extra,
               texlive-fonts-recommended,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-latex-recommended
Standards-Version: 4.5.0
Homepage: http://coccinelle.lip6.fr
Vcs-Git: https://salsa.debian.org/ocaml-team/coccinelle.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/coccinelle

Package: coccinelle
Architecture: any
Depends: libparmap-ocaml,
         ocaml-findlib,
         ${misc:Depends},
         ${ocaml:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.17.14)
Suggests: coccinelle-doc, vim-addon-manager
Description: semantic patching tool for C
 Coccinelle is a program matching and transformation tool for C.
 The programmer describes the code to match and the transformation to
 perform as a semantic patch, which looks like a standard patch, but can
 transform multiple files at any number of code sites.

Package: coccinelle-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: coccinelle (<< 1.0.0~rc7.deb-4)
Replaces: coccinelle (<< 1.0.0~rc7.deb-4)
Description: documentation for coccinelle
 Coccinelle is a program matching and transformation tool for C.
 The programmer describes the code to match and the transformation to
 perform as a semantic patch, which looks like a standard patch, but can
 transform multiple files at any number of code sites.
 .
 This package contains examples files and additional documentation in
 PDF format.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

VIM_ADIR = $(CURDIR)/debian/coccinelle/usr/share/vim/addons
VIM_RDIR = $(CURDIR)/debian/coccinelle/usr/share/vim/registry

CONFIG_FLAGS = --prefix=/usr --sysconfdir=/etc --libdir=/usr/lib --enable-ocaml

ifeq ($(OCAML_NATDYNLINK),yes)
CONFIG_FLAGS += --enable-opt
else
CONFIG_FLAGS += --disable-opt
endif

%:
	dh $@ --with ocaml,python3,autoreconf

override_dh_auto_configure:
	./configure $(CONFIG_FLAGS)

override_dh_auto_build-indep:
	$(MAKE) -C docs/manual pdf

override_dh_auto_test-arch:
	$(MAKE) check || echo "IGNORING FAILED TESTS"

override_dh_auto_test-indep:
	# nothing

override_dh_auto_install-arch:
	$(MAKE) DESTDIR=$(CURDIR)/debian/coccinelle install install-bash

	# Vim files
	install -d $(VIM_ADIR)/ftdetect $(VIM_ADIR)/syntax
	cp $(CURDIR)/editors/vim/ftdetect/cocci.vim $(VIM_ADIR)/ftdetect/
	cp $(CURDIR)/editors/vim/syntax/cocci.vim $(VIM_ADIR)/syntax/
	install -d $(VIM_RDIR)
	cp $(CURDIR)/debian/coccinelle.yaml $(VIM_RDIR)/

	# Emacs files
	cp $(CURDIR)/editors/emacs/cocci.el $(CURDIR)/debian/coccinelle/usr/share/emacs/site-lisp/

override_dh_auto_install-indep:
	# Nothing

override_dh_compress:
	dh_compress -X.pdf -X.cocci -X.c

=== debian/tests/control ===
Tests: cocci-demo
Depends: coccinelle, patch
